# Spotify Apps API Tutorial

This is a Spotify App that shows useful code snippets that can help you build
[Spotify Apps](https://developer.spotify.com/technologies/apps/). It uses the most recent version of the Spotify Apps API.

## Installation

 1. Sign up for a [developer account on Spotify](https://developer.spotify.com/technologies/apps/#developer) by logging in and agreeing to the [terms of use](https://developer.spotify.com/technologies/apps/terms-of-use/).
 2. Create the Spotify folder if it doesn't exist already: `~/Spotify` (Mac OS X and Linux) or `My Documents\Spotify` (Windows).
 3. Open the Spotify folder.
 4. Run `git clone git://github.com/spotify/apps-tutorial.git api-tutorial`.
 5. Download the [latest version of Spotify](http://spotify.com/download).
 6. Open Spotify and type "spotify:app:api-tutorial" in the search bar (restart Spotify completely in case it doesn't find the App at first).

## Topics covered

#### Getting started

 * Creating your manifest file
 * Handling arguments, creating pages and navigational tabs
 * Dragging and dropping content into an app

#### UI

 * Show "Share" popup

#### Playing music

 * Play a single track
 * Play a list of tracks
 * Get the currently playing track
 * Create a play/pause button with an HTML element
 * Skip to the next or previous track

#### Searching

 * Get metadata from an artist, album, track, or playlist
 * Returning metadata with a given search query

#### Interacting with user data

 * Get a user's top tracks
 * Star and unstar a track

#### Facebook

 * Authenticate a user with Facebook

## More information

 * [API Reference](https://developer.spotify.com/technologies/apps/docs/)
 * [Integration Guidelines](http://developer.spotify.com/download/spotify-apps-api/guidelines/)
 * [Spotify-tagged questions on StackOverflow](http://stackoverflow.com/questions/tagged/spotify)
 * [@SpotifyPlatform](https://twitter.com/#!/SpotifyPlatform) on Twitter

Your feedback is welcome! Feel free to create issues and send pull requests.
